(* Copyright (C) 1994, Digital Equipment Corporation *)
(* All rights reserved.                              *)
(* See the file COPYRIGHT for a full description.    *)

(* This interface exports the configuration information
   used by m3build and quake.  These constants were defined
   when Modula-3 was installed. *)

INTERFACE M3Config;

CONST  (* misc. configuration *)
  TARGET    = "LINUXLIBC6";
  OS_TYPE   = "POSIX";
  WORD_SIZE = "32BITS";
  BUILD_DIR = "LINUXLIBC6";
  PATH_SEP  = "/";
  M3        = "/var/tmp/cm3/bin/cm3"; (* the compiler *)

CONST (* installation directories *)
  BIN_INSTALL   = "/var/tmp/cm3/bin";
  LIB_INSTALL   = "/var/tmp/cm3/lib";
  DOC_INSTALL   = "/var/tmp/cm3/doc";
  PKG_INSTALL   = "/var/tmp/cm3/pkg";
  MAN_INSTALL   = "/var/tmp/cm3/man";
  EMACS_INSTALL = "/var/tmp/cm3/elisp";
  HTML_INSTALL  = "/var/tmp/cm3/www";

(* On some systems (e.g. AFS) you must install public files
   in a different place from where you use them.  The paths
   below specify where to find the installed files. *)

CONST
  BIN_USE   = "/var/tmp/cm3/bin";
  LIB_USE   = "/var/tmp/cm3/lib";
  DOC_USE   = "/var/tmp/cm3/doc";
  PKG_USE   = "/var/tmp/cm3/pkg";
  MAN_USE   = "/var/tmp/cm3/man";
  EMACS_USE = "/var/tmp/cm3/elisp";
  HTML_USE  = "/var/tmp/cm3/www";

END M3Config.
